<?php
declare(strict_types=1);

namespace Flat101\Base\Service;

use Magento\Catalog\Api\Data\ProductInterface;
use Magento\Catalog\Api\Data\ProductInterfaceFactory;

/**
 *  CurrentProductDataProvider
 */
class GetCurrentProductService
{
    /** @var ProductInterface */
    private $product;

    /** @var ProductInterfaceFactory */
    private $productFactory;

    public function __construct(
        ProductInterfaceFactory $productFactory)
    {
        $this->productFactory = $productFactory;
    }

    public function setProduct(ProductInterface $product): void
    {
        $this->product = $product;
    }

    public function getProduct(): ProductInterface
    {
        return $this->product ?? $this->createNullProduct();
    }

    private function createNullProduct(): ProductInterface
    {
        return $this->productFactory->create();
    }
}
